----------------------------------------------------------
-- Beispielskript zur SNEK 5 im Mrz 2016 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Beispielskript 09 - Dynamic Data Masking - Daten ndern
----------------------------------------------------------
USE SNEK;
GO


-- Maskieren der Spalte Email mit eigener partieller Maskierung
ALTER TABLE dbo.Personal ALTER COLUMN Email
		ADD MASKED WITH (FUNCTION = 'partial(2," -_- ", 2)');


-- Datensatz als Benutzer Bundestrojaner anlegen
EXECUTE AS USER = 'Bundestrojaner';
INSERT INTO dbo.Personal (Nachname, Vorname, Anrede, Einstellung, Email)
	 VALUES ('Donaubauer', 'Karl', 'Herr', GETDATE(), 'aek@donkarl.com');
REVERT;

-- Daten als dbo ausgeben
SELECT	Nachname, Vorname, Email 
FROM	dbo.Personal 
WHERE	Nachname = 'Donaubauer';

-- Daten als Benutzer Bundestrojaner ausgeben
EXECUTE AS USER = 'Bundestrojaner';
SELECT	Nachname, Vorname, Email 
FROM	dbo.Personal 
WHERE	Nachname = 'Donaubauer';
REVERT;


-- Datensatz als Benutzer Bundestrojaner ndern
EXECUTE AS USER = 'Bundestrojaner';
UPDATE	dbo.Personal 
SET		Email = 'snek@donkarl.com' 
WHERE	Nachname = 'Donaubauer';
REVERT;

-- Daten als dbo Bundestrojaner ausgeben
SELECT	Nachname, Vorname, Email 
FROM	dbo.Personal 
WHERE	Nachname = 'Donaubauer';

-- Daten als Benutzer Bundestrojaner ausgeben
EXECUTE AS USER = 'Bundestrojaner';
SELECT	Nachname, Vorname, Email 
FROM	dbo.Personal 
WHERE	Nachname = 'Donaubauer';
REVERT;

-- Denksportaufgabe
-- Wie mag die Maskierung wohl nach einem DELETE aussehen?
--> :-)