-----------------------------------------------------
-- Beispielskript zur SNEK 5 im Mrz 2016 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Beispielskript 02 - Temporal Table nutzen
-----------------------------------------------------
USE SNEK;
GO


-- Verkaufspreis ArtikelID 7 ausgeben
SELECT ArtikelID, Verkaufspreis FROM dbo.Artikel WHERE ArtikelID = 7;
-- Verkaufspreis ArtikelID 7 ndern
UPDATE dbo.Artikel SET Verkaufspreis = 0.87 WHERE ArtikelID = 7;

-- Daten und Gltigkeitszeitraum zu ArtikelID ausgeben
SELECT	ArtikelID, Verkaufspreis, AktuellVon, AktuellBis 
FROM	dbo.Artikel 
WHERE	ArtikelID = 7;

-- Daten der zugehrigen Temporal Table ausgeben
SELECT * FROM Historie.Artikel;


-- Datensatz hinzufgen
INSERT INTO dbo.Artikel (Matchcode, Artikel, ArtikelgruppeID, Verkaufspreis, Auslaufartikel)
	 VALUES ('SR1RO3538', 'Sportsocke "Run" - 35-38 - rot', 3, 1, 0);
SELECT SCOPE_IDENTITY() As NeueArtikelID;

-- Neuen Datensatz anzeigen
SELECT	ArtikelID, Verkaufspreis, AktuellVon, AktuellBis 
FROM	dbo.Artikel 
WHERE	ArtikelID = 37;

-- Inhalt der Temporal Table ausgeben
SELECT	ArtikelID, Verkaufspreis, AktuellVon, AktuellBis  
FROM	Historie.Artikel;
--> Kein Eintrag zu INSERT!


-- Datensatz lschen
DELETE FROM dbo.Artikel WHERE ArtikelID = 30;

-- Lschen vom Datensatz prfen
SELECT	ArtikelID, Verkaufspreis, AktuellVon, AktuellBis  
FROM	dbo.Artikel 
WHERE	ArtikelID = 30;

-- Inhalt der Temporal Table ausgeben
SELECT	ArtikelID, Verkaufspreis, AktuellVon, AktuellBis 
FROM	Historie.Artikel;
--> Eintrag zu DELETE