--------------------------------------------------------
-- Beispielskript zur SNEK 5 im Mrz 2016 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Beispielskript 06 - Row Level Security - Daten ndern
--------------------------------------------------------
USE SNEK;
GO


-- Auftrag als Lebhausen (PersonalID 9) mit PersonalID 1 anlegen
EXECUTE As USER = 'Lebhausen';
INSERT INTO dbo.Auftraege (KontaktID, PersonalID, Auftragsdatum) 
			VALUES (1, 1, GETDATE());
SELECT SCOPE_IDENTITY() As NeuerAuftrag;
REVERT;

-- Neuen Datensatz ausgeben
EXECUTE As USER = 'Lebhausen';
SELECT	KontaktID, PersonalID, Auftragsdatum
FROM	dbo.Auftraege 
WHERE	AuftragID = 5583;
REVERT;


-- Auftrag mit PersonalID 1 als Lebhausen (PersonalID 9) ndern
EXECUTE As USER = 'Lebhausen';
UPDATE	dbo.Auftraege 
SET		PersonalID = 9 
WHERE	AuftragID = 5583;
REVERT;

-- Genderten Datensatz ausgeben
SELECT	KontaktID, PersonalID, Auftragsdatum 
FROM	dbo.Auftraege 
WHERE	AuftragID = 5583;
--> PersonalID = 1

-- Auftrag mit PersonalID 1 als Lebhausen (PersonalID 9) lschen
EXECUTE As USER = 'Lebhausen';
DELETE	FROM dbo.Auftraege 
WHERE	AuftragID = 5583;;
REVERT;

-- Gelschten Datensatz prfen
SELECT	KontaktID, PersonalID, Auftragsdatum 
FROM	dbo.Auftraege 
WHERE	AuftragID = 5583;
--> Datensatz nicht gelscht